Index: xen-4.0.3-testing/docs/Makefile
===================================================================
--- xen-4.0.3-testing.orig/docs/Makefile
+++ xen-4.0.3-testing/docs/Makefile
@@ -90,7 +90,8 @@ install: all
 	$(INSTALL_DIR) $(DESTDIR)$(MANDIR)
 	cp -dR man1 $(DESTDIR)$(MANDIR)
 	cp -dR man5 $(DESTDIR)$(MANDIR)
-	[ ! -d html ] || cp -dR html $(DESTDIR)$(DOCDIR)
+	$(INSTALL_DIR) $(DESTDIR)$(DOCDIR)/html
+	cp -dR html.done/* $(DESTDIR)$(DOCDIR)/html
 
 pdf/%.pdf: ps/%.ps
 	$(INSTALL_DIR) $(@D)
@@ -114,3 +115,9 @@ html/%/index.html: src/%.tex
 	$(LATEX2HTML) -split 0 -show_section_numbers -toc_depth 3 -nonavigation \
 	-numbered_footnotes -local_icons -noinfo -math -dir $(@D) \
 	$< 1>/dev/null 2>/dev/null
+	rm -rf html.done/$*/
+	mkdir -p html.done/$*/
+	cp html/$*/*.html html/$*/*.css html/$*/*.png html.done/$*/
+	ln -sf $*.html html.done/$*/index.html
+	rm -rf html/
+
Index: xen-4.0.3-testing/tools/security/Makefile
===================================================================
--- xen-4.0.3-testing.orig/tools/security/Makefile
+++ xen-4.0.3-testing/tools/security/Makefile
@@ -60,8 +60,8 @@ install: all $(ACM_CONFIG_FILE)
 	$(INSTALL_DATA) $(ACM_INST_HTML) $(DESTDIR)$(ACM_SECGEN_HTMLDIR)
 	$(INSTALL_DIR) $(DESTDIR)$(ACM_SECGEN_CGIDIR)
 	$(INSTALL_PROG) $(ACM_INST_CGI) $(DESTDIR)$(ACM_SECGEN_CGIDIR)
-	$(PYTHON) python/setup.py install $(PYTHON_PREFIX_ARG) \
-		--root="$(DESTDIR)" --force
+	$(PYTHON) python/setup.py install \
+		--prefix="/usr" --root="$(DESTDIR)" --force
 else
 .PHONY: all
 all:
Index: xen-4.0.3-testing/tools/pygrub/Makefile
===================================================================
--- xen-4.0.3-testing.orig/tools/pygrub/Makefile
+++ xen-4.0.3-testing/tools/pygrub/Makefile
@@ -11,7 +11,7 @@ build:
 .PHONY: install
 install: all
 	CC="$(CC)" CFLAGS="$(CFLAGS)" $(PYTHON) setup.py install \
-		$(PYTHON_PREFIX_ARG) --root="$(DESTDIR)" --force
+		--prefix="/usr" --root="$(DESTDIR)" --force
 	$(INSTALL_PYTHON_PROG) src/pygrub $(DESTDIR)/$(BINDIR)/pygrub
 	$(INSTALL_DIR) $(DESTDIR)/var/run/xend/boot
 
Index: xen-4.0.3-testing/tools/python/Makefile
===================================================================
--- xen-4.0.3-testing.orig/tools/python/Makefile
+++ xen-4.0.3-testing/tools/python/Makefile
@@ -60,7 +60,7 @@ refresh-po: $(POTFILE)
 .PHONY: install
 install: install-messages install-dtd
 	CC="$(CC)" CFLAGS="$(CFLAGS)" $(PYTHON) setup.py install \
-		$(PYTHON_PREFIX_ARG) --root="$(DESTDIR)" --force
+		--prefix="/usr" --root="$(DESTDIR)" --force
 
 install-dtd: all
 	$(INSTALL_DIR) $(DESTDIR)$(SHAREDIR)/xen
Index: xen-4.0.3-testing/tools/xenstore/Makefile
===================================================================
--- xen-4.0.3-testing.orig/tools/xenstore/Makefile
+++ xen-4.0.3-testing/tools/xenstore/Makefile
@@ -10,6 +10,7 @@ CFLAGS += $(CFLAGS_libxenctrl)
 
 CLIENTS := xenstore-exists xenstore-list xenstore-read xenstore-rm xenstore-chmod
 CLIENTS += xenstore-write xenstore-ls
+CLIENTS_DOMU := $(patsubst xenstore-%,domu-xenstore-%,$(CLIENTS))
 
 XENSTORED_OBJS = xenstored_core.o xenstored_watch.o xenstored_domain.o xenstored_transaction.o xs_lib.o talloc.o utils.o tdb.o hashtable.o
 
@@ -35,7 +36,7 @@ endif
 all: $(ALL_TARGETS)
 
 .PHONY: clients
-clients: xenstore $(CLIENTS) xenstore-control
+clients: xenstore $(CLIENTS) $(CLIENTS_DOMU) xenstore-control
 
 ifeq ($(CONFIG_SunOS),y)
 xenstored_probes.h: xenstored_probes.d
@@ -55,6 +56,9 @@ xenstored: $(XENSTORED_OBJS)
 $(CLIENTS): xenstore
 	ln -f xenstore $@
 
+$(CLIENTS_DOMU): xenstore
+	ln -f xenstore $@
+
 xenstore: xenstore_client.o $(LIBXENSTORE)
 	$(CC) $(CFLAGS) $(LDFLAGS) $< -L. -lxenstore $(SOCKET_LIBS) -o $@
 
@@ -82,7 +86,7 @@ clean:
 	rm -f *.a *.o *.opic *.so* xenstored_probes.h
 	rm -f xenstored xs_random xs_stress xs_crashme
 	rm -f xs_tdb_dump xenstore-control
-	rm -f xenstore $(CLIENTS)
+	rm -f $(CLIENTS) $(CLIENTS_DOMU)
 	$(RM) $(DEPS)
 
 .PHONY: TAGS
@@ -100,6 +104,7 @@ ifneq ($(CONFIG_OCAML_XENSTORED),y)
 	$(INSTALL_DIR) $(DESTDIR)/var/lib/xenstored
 	$(INSTALL_PROG) xenstored $(DESTDIR)$(SBINDIR)
 endif
+	$(INSTALL_DIR) $(DESTDIR)/bin
 	$(INSTALL_DIR) $(DESTDIR)$(BINDIR)
 	$(INSTALL_DIR) $(DESTDIR)$(SBINDIR)
 	$(INSTALL_DIR) $(DESTDIR)$(INCLUDEDIR)
@@ -108,6 +113,9 @@ endif
 	set -e ; for c in $(CLIENTS) ; do \
 		ln -f $(DESTDIR)$(BINDIR)/xenstore $(DESTDIR)$(BINDIR)/$${c} ; \
 	done
+	for client in $(CLIENTS_DOMU); do \
+	    $(INSTALL_PROG) $$client $(DESTDIR)/bin/$${client/domu-}; \
+	done
 	$(INSTALL_DIR) $(DESTDIR)$(LIBDIR)
 	$(INSTALL_PROG) libxenstore.so.$(MAJOR).$(MINOR) $(DESTDIR)$(LIBDIR)
 	ln -sf libxenstore.so.$(MAJOR).$(MINOR) $(DESTDIR)$(LIBDIR)/libxenstore.so.$(MAJOR)
Index: xen-4.0.3-testing/tools/hotplug/Linux/Makefile
===================================================================
--- xen-4.0.3-testing.orig/tools/hotplug/Linux/Makefile
+++ xen-4.0.3-testing/tools/hotplug/Linux/Makefile
@@ -39,18 +39,6 @@ endif
 UDEV_RULES_DIR = $(CONFIG_DIR)/udev
 UDEV_RULES = xen-backend.rules xend.rules
 
-DI = $(if $(DISTDIR),$(shell readlink -f $(DISTDIR)),)
-DE = $(if $(DESTDIR),$(shell readlink -f $(DESTDIR)),)
-ifeq ($(findstring $(DI),$(DE)),$(DI))
-HOTPLUGS=install-hotplug install-udev
-else
-ifeq ($(shell [ $(UDEVVER) -ge 059 ] && echo 1),1)
-HOTPLUGS=install-udev
-else
-HOTPLUGS=install-hotplug
-endif
-endif
-
 .PHONY: all
 all:
 
@@ -58,17 +46,17 @@ all:
 build:
 
 .PHONY: install
-install: all install-initd install-scripts $(HOTPLUGS)
+install: all install-initd install-scripts install-udev
 
 .PHONY: install-initd
 install-initd:
 	[ -d $(DESTDIR)$(CONFIG_DIR)/init.d ] || $(INSTALL_DIR) $(DESTDIR)$(CONFIG_DIR)/init.d
-	[ -d $(DESTDIR)$(CONFIG_DIR)/sysconfig ] || $(INSTALL_DIR) $(DESTDIR)$(CONFIG_DIR)/sysconfig
+	[ -d $(DESTDIR)/var/adm/fillup-templates ] || $(INSTALL_DIR) $(DESTDIR)/var/adm/fillup-templates/
 	$(INSTALL_PROG) $(XEND_INITD) $(DESTDIR)$(CONFIG_DIR)/init.d
-	$(INSTALL_PROG) $(XEND_SYSCONFIG) $(DESTDIR)$(CONFIG_DIR)/sysconfig/xend
+	$(INSTALL_PROG) $(XEND_SYSCONFIG) $(DESTDIR)/var/adm/fillup-templates/
 	$(INSTALL_PROG) $(XENCOMMONS_INITD) $(DESTDIR)$(CONFIG_DIR)/init.d
 	$(INSTALL_PROG) $(XENDOMAINS_INITD) $(DESTDIR)$(CONFIG_DIR)/init.d
-	$(INSTALL_PROG) $(XENDOMAINS_SYSCONFIG) $(DESTDIR)$(CONFIG_DIR)/sysconfig/xendomains
+	$(INSTALL_PROG) $(XENDOMAINS_SYSCONFIG) $(DESTDIR)/var/adm/fillup-templates/
 
 .PHONY: install-scripts
 install-scripts:
@@ -98,8 +86,7 @@ install-udev:
 		$(INSTALL_DIR) $(DESTDIR)$(UDEV_RULES_DIR)/rules.d
 	set -e; for i in $(UDEV_RULES); \
 	    do \
-	    $(INSTALL_DATA) $$i $(DESTDIR)$(UDEV_RULES_DIR); \
-	    ln -sf ../$$i $(DESTDIR)$(UDEV_RULES_DIR)/rules.d; \
+	    $(INSTALL_DATA) $$i $(DESTDIR)$(UDEV_RULES_DIR)/rules.d; \
 	done
 
 .PHONY: clean